drama.shaders = {};
drama.shaders["blurhorizontal"] = {
	src: "varying mediump vec2 vTex;\nuniform mediump sampler2D samplerFront;\n\nuniform mediump vec2 pixelSize;\nuniform mediump float intensity;\n\nvoid main(void)\n{\n	mediump vec4 sum = vec4(0.0);\n	mediump float pixelWidth = pixelSize.x;\n	mediump float halfPixelWidth = pixelWidth / 2.0;	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 7.0 + halfPixelWidth, 0.0)) * 0.06;\n	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 5.0 + halfPixelWidth, 0.0)) * 0.10;\n	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 3.0 + halfPixelWidth, 0.0)) * 0.13;\n	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 1.0 + halfPixelWidth, 0.0)) * 0.16;\n	mediump vec4 front = texture2D(samplerFront, vTex);\n	sum += front * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 1.0 + halfPixelWidth, 0.0)) * 0.16;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 3.0 + halfPixelWidth, 0.0)) * 0.13;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 5.0 + halfPixelWidth, 0.0)) * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 7.0 + halfPixelWidth, 0.0)) * 0.06;\n	\n	gl_FragColor = mix(front, sum, intensity);\n}\n",
	extendBoxHorizontal: 8,
	extendBoxVertical: 8,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: [["intensity",0,1]]
};

drama.shaders["blurvertical"] = {
	src: "varying mediump vec2 vTex;\nuniform mediump sampler2D samplerFront;\n\nuniform mediump vec2 pixelSize;\nuniform mediump float intensity;\n\nvoid main(void)\n{\n	mediump vec4 sum = vec4(0.0);\n	mediump float pixelHeight = pixelSize.y;\n	mediump float halfPixelHeight = pixelHeight / 2.0;	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 7.0 + halfPixelHeight)) * 0.06;\n	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 5.0 + halfPixelHeight)) * 0.10;\n	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 3.0 + halfPixelHeight)) * 0.13;\n	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 1.0 + halfPixelHeight)) * 0.16;\n	mediump vec4 front = texture2D(samplerFront, vTex);\n	sum += front * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 1.0 + halfPixelHeight)) * 0.16;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 3.0 + halfPixelHeight)) * 0.13;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 5.0 + halfPixelHeight)) * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 7.0 + halfPixelHeight)) * 0.06;\n	\n	gl_FragColor = mix(front, sum, intensity);\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: [["intensity",0,1]]
};

drama.shaders["gamma"] = {
	src: "varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump float gamma;\n\nvoid main(void)\n{	\n	lowp vec4 front = texture2D(samplerFront, vTex);\n	\n	gl_FragColor = vec4(pow(front.rgb, vec3(gamma)), front.a);\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: true,
	animated: false,
	parameters: [["gamma",0,0]]
};

drama.shaders["glowhorizontal"] = {
	src: "varying mediump vec2 vTex;\nuniform mediump sampler2D samplerFront;\n\nuniform mediump vec2 pixelSize;\nuniform mediump float intensity;\n\nvoid main(void)\n{\n	mediump vec4 sum = vec4(0.0);\n	mediump float pixelWidth = pixelSize.x;\n	mediump float halfPixelWidth = pixelWidth / 2.0;	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 7.0 + halfPixelWidth, 0.0)) * 0.06;\n	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 5.0 + halfPixelWidth, 0.0)) * 0.10;\n	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 3.0 + halfPixelWidth, 0.0)) * 0.13;\n	sum += texture2D(samplerFront, vTex - vec2(pixelWidth * 1.0 + halfPixelWidth, 0.0)) * 0.16;\n	mediump vec4 front = texture2D(samplerFront, vTex);\n	sum += front * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 1.0 + halfPixelWidth, 0.0)) * 0.16;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 3.0 + halfPixelWidth, 0.0)) * 0.13;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 5.0 + halfPixelWidth, 0.0)) * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(pixelWidth * 7.0 + halfPixelWidth, 0.0)) * 0.06;\n	\n	gl_FragColor = mix(front, max(front, sum), intensity);\n}\n",
	extendBoxHorizontal: 8,
	extendBoxVertical: 8,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: [["intensity",0,1]]
};

drama.shaders["glowvertical"] = {
	src: "varying mediump vec2 vTex;\nuniform mediump sampler2D samplerFront;\n\nuniform mediump vec2 pixelSize;\nuniform mediump float intensity;\n\nvoid main(void)\n{\n	mediump vec4 sum = vec4(0.0);\n	mediump float pixelHeight = pixelSize.y;\n	mediump float halfPixelHeight = pixelHeight / 2.0;	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 7.0 + halfPixelHeight)) * 0.06;\n	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 5.0 + halfPixelHeight)) * 0.10;\n	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 3.0 + halfPixelHeight)) * 0.13;\n	sum += texture2D(samplerFront, vTex - vec2(0.0, pixelHeight * 1.0 + halfPixelHeight)) * 0.16;\n	mediump vec4 front = texture2D(samplerFront, vTex);\n	sum += front * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 1.0 + halfPixelHeight)) * 0.16;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 3.0 + halfPixelHeight)) * 0.13;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 5.0 + halfPixelHeight)) * 0.10;\n	sum += texture2D(samplerFront, vTex + vec2(0.0, pixelHeight * 7.0 + halfPixelHeight)) * 0.06;\n	\n	gl_FragColor = mix(front, max(front, sum), intensity);\n}\n",
	extendBoxHorizontal: 0,
	extendBoxVertical: 0,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: [["intensity",0,1]]
};

drama.shaders["radialblur"] = {
	src: "precision mediump float;\nvarying vec2 vTex;\nuniform sampler2D samplerFront;\nuniform vec2 srcStart;\nuniform vec2 srcEnd;\nuniform float layerScale;\n\nuniform float intensity;\nuniform float radius;\n\nvoid main(void)\n{\n	vec2 dir = ((srcStart + srcEnd) / 2.0 - vTex) / (length(srcEnd - srcStart) / 2.0); \n	float dist = sqrt(dir.x*dir.x + dir.y*dir.y); \n	dir = dir/dist; \n	vec4 front = texture2D(samplerFront, vTex); \n\n	vec4 sum = front;\n	float scaledRadius = radius * layerScale;\n\n	sum += texture2D(samplerFront, vTex + dir * -0.08 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * -0.05 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * -0.03 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * -0.02 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * -0.01 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * 0.01 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * 0.02 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * 0.03 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * 0.05 * scaledRadius);\n	sum += texture2D(samplerFront, vTex + dir * 0.08 * scaledRadius);\n\n	sum /= 11.0;\n\n	float t = dist * 2.2;\n	t = clamp(t, 0.0, 1.0);\n\n	gl_FragColor = mix(front, mix(front, sum, t), intensity);\n}\n",
	extendBoxHorizontal: 50,
	extendBoxVertical: 50,
	crossSampling: false,
	preservesOpaqueness: false,
	animated: false,
	parameters: [["radius",0,1],["intensity",0,1]]
};
